# generated by datamodel-codegen:
#   filename:  properties_directory/non_scalar/total_energy_contributions.json
#   version:   0.28.5

from __future__ import annotations

from enum import Enum
from typing import Optional

from pydantic import BaseModel, Field


class Name(Enum):
    temperature_entropy = "temperature_entropy"


class ScalarSchema(BaseModel):
    name: Optional[Name] = None
    value: float


class Name82(Enum):
    harris_foulkes = "harris_foulkes"


class ScalarSchema7(BaseModel):
    name: Optional[Name82] = None
    value: float


class Name83(Enum):
    one_electron = "one_electron"


class ScalarSchema8(BaseModel):
    name: Optional[Name83] = None
    value: float


class Name84(Enum):
    hartree = "hartree"


class ScalarSchema9(BaseModel):
    name: Optional[Name84] = None
    value: float


class Name85(Enum):
    exchange = "exchange"


class ScalarSchema10(BaseModel):
    name: Optional[Name85] = None
    value: float


class Name86(Enum):
    exchange_correlation = "exchange_correlation"


class ScalarSchema11(BaseModel):
    name: Optional[Name86] = None
    value: float


class Name87(Enum):
    ewald = "ewald"


class ScalarSchema12(BaseModel):
    name: Optional[Name87] = None
    value: float


class Name88(Enum):
    alphaZ = "alphaZ"


class ScalarSchema13(BaseModel):
    name: Optional[Name88] = None
    value: float


class Name89(Enum):
    atomic_energy = "atomic_energy"


class ScalarSchema14(BaseModel):
    name: Optional[Name89] = None
    value: float


class Name90(Enum):
    eigenvalues = "eigenvalues"


class ScalarSchema15(BaseModel):
    name: Optional[Name90] = None
    value: float


class Name91(Enum):
    PAW_double_counting_correction_2 = "PAW_double-counting_correction_2"


class ScalarSchema16(BaseModel):
    name: Optional[Name91] = None
    value: float


class Name92(Enum):
    PAW_double_counting_correction_3 = "PAW_double-counting_correction_3"


class ScalarSchema17(BaseModel):
    name: Optional[Name92] = None
    value: float


class Name93(Enum):
    hartree_fock = "hartree_fock"


class ScalarSchema18(BaseModel):
    name: Optional[Name93] = None
    value: float


class Name94(Enum):
    total_energy_contributions = "total_energy_contributions"


class Units(Enum):
    kJ_mol = "kJ/mol"
    eV = "eV"
    J_mol = "J/mol"
    hartree = "hartree"
    cm_1 = "cm-1"
    Ry = "Ry"
    eV_atom = "eV/atom"


class TotalEnergyContributionsSchema(BaseModel):
    temperatureEntropy: Optional[ScalarSchema] = Field(None, title="scalar schema")
    """
    product of temperature and configurational entropy
    """
    harrisFoulkes: Optional[ScalarSchema7] = Field(None, title="scalar schema")
    """
    non self-consitent energy based on an input charge density
    """
    oneElectron: Optional[ScalarSchema8] = Field(None, title="scalar schema")
    """
    kinetic + pseudopotential energy
    """
    hartree: Optional[ScalarSchema9] = Field(None, title="scalar schema")
    """
    energy due to coulomb potential
    """
    exchange: Optional[ScalarSchema10] = Field(None, title="scalar schema")
    """
    exchange energy
    """
    exchangeCorrelation: Optional[ScalarSchema11] = Field(None, title="scalar schema")
    """
    exchange and correlation energy per particle
    """
    ewald: Optional[ScalarSchema12] = Field(None, title="scalar schema")
    """
    summation of interaction energies at long length scales due to coloumbic interactions
    """
    alphaZ: Optional[ScalarSchema13] = Field(None, title="scalar schema")
    """
    divergent electrostatic ion interaction in compensating electron gas
    """
    atomicEnergy: Optional[ScalarSchema14] = Field(None, title="scalar schema")
    """
    kinetic energy of wavefunctions in the atomic limit
    """
    eigenvalues: Optional[ScalarSchema15] = Field(None, title="scalar schema")
    """
    sum of one electron energies of kinetic, electrostatic, and exchange correlation
    """
    PAWDoubleCounting2: Optional[ScalarSchema16] = Field(None, title="scalar schema")
    """
    double counting correction 2
    """
    PAWDoubleCounting3: Optional[ScalarSchema17] = Field(None, title="scalar schema")
    """
    double counting correction 3
    """
    hartreeFock: Optional[ScalarSchema18] = Field(None, title="scalar schema")
    """
    hartree-fock contribution
    """
    name: Optional[Name94] = None
    units: Optional[Units] = None
