# generated by datamodel-codegen:
#   filename:  software_directory/modeling/deepmd.json
#   version:   0.28.5

from __future__ import annotations

from enum import Enum
from typing import Optional

from pydantic import BaseModel, ConfigDict, Field


class Name(Enum):
    deepmd = "deepmd"


class Summary(Enum):
    DeePMD_is_a_deep_learning_package_that_is_based_on_neural_network_fitted_first_principles_data_for_many_body_potential_energy_representation_and_molecular_dynamics = "DeePMD is a deep learning package that is based on neural network fitted first-principles data for many-body potential energy representation and molecular dynamics"


class Version(Enum):
    field_2_0_2 = "2.0.2"


class Exec(Enum):
    dp = "dp"
    lmp = "lmp"
    python = "python"


class DeePMDAppSchema(BaseModel):
    model_config = ConfigDict(
        extra="allow",
    )
    name: Optional[Name] = None
    """
    entity name
    """
    summary: Optional[Summary] = None
    """
    Application's short description.
    """
    version: Optional[Version] = None
    """
    Application version. e.g. 5.3.5
    """
    exec: Optional[Exec] = None
    shortName: Optional[str] = None
    """
    The short name of the application. e.g. qe
    """
    build: Optional[str] = None
    """
    Application build. e.g. VTST
    """
    hasAdvancedComputeOptions: Optional[bool] = None
    """
    Whether advanced compute options are present
    """
    isLicensed: Optional[bool] = None
    """
    Whether licensing is present
    """
    field_id: Optional[str] = Field(None, alias="_id")
    """
    entity identity
    """
    slug: Optional[str] = None
    """
    entity slug
    """
    systemName: Optional[str] = None
    schemaVersion: Optional[str] = "2022.8.16"
    """
    entity's schema version. Used to distinct between different schemas.
    """
    isDefault: Optional[bool] = False
    """
    Identifies that entity is defaultable
    """
